package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRDistribution;
import cn.ibizlab.humanresource.core.humanresource.filter.HRDistributionSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRDistribution] 服务对象接口
 */
public interface IHRDistributionService extends IService<HRDistribution>{

    boolean create(HRDistribution et) ;
    void createBatch(List<HRDistribution> list) ;
    boolean update(HRDistribution et) ;
    void updateBatch(List<HRDistribution> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRDistribution get(String key) ;
    HRDistribution getDraft(HRDistribution et) ;
    boolean checkKey(HRDistribution et) ;
    boolean save(HRDistribution et) ;
    void saveBatch(List<HRDistribution> list) ;
    Page<HRDistribution> searchDefault(HRDistributionSearchContext context) ;
    List<HRDistribution> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    List<HRDistribution> selectByHrpostid(String hrpostid) ;
    void removeByHrpostid(String hrpostid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRDistribution> getHrdistributionByIds(List<String> ids) ;
    List<HRDistribution> getHrdistributionByEntities(List<HRDistribution> entities) ;
}


